#-------------------------------------------------
#
# Project created by QtCreator 2019-10-17T11:19:58
#
#-------------------------------------------------
CONFIG += c++11


greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = GarageMeasurement
TEMPLATE = app

QMAKE_CXXFLAGS += -std=c++0x
# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

# add pcl
INCLUDEPATH += /usr/include/eigen3
#INCLUDEPATH += /usr/include/vtk-6.2
#LIBS += /usr/lib/x86_64-linux-gnu/libvtk*.so
INCLUDEPATH += /usr/include/boost
LIBS += /usr/lib/x86_64-linux-gnu/libboost_*.so
INCLUDEPATH += /usr/include/pcl-1.7/
LIBS += /usr/lib/x86_64-linux-gnu/libpcl_*.so

# add opencv 34
INCLUDEPATH += /opt/ros/kinetic/include/opencv-3.3.1-dev
DEPENDPATH += /opt/ros/kinetic/lib/x86_64-linux-gnu/
LIBS += /opt/ros/kinetic/lib/x86_64-linux-gnu/libopencv_*.so

#livox sdk  apr lib
LIBS += /usr/local/lib/liblivox_sdk_static.a
LIBS += /usr/local/apr/lib/libapr-1.a

# glog protobuf gflags
LIBS += /usr/local/lib/libglog.a
LIBS += /usr/local/lib/libgflags.a
LIBS += /usr/local/lib/libprotobuf.a


# modubus
INCLUDEPATH += /usr/local/include/modbus
LIBS += /usr/local/lib/libmodbus.so

#cuda
LIBS += /usr/local/cuda/lib64/libcublas.so
LIBS += /usr/local/cuda/lib64/libcusolver.so
LIBS += /usr/local/cuda/lib64/libcudnn.so
LIBS += /usr/local/cuda/lib64/libcudart.so
LIBS += /usr/local/cuda/lib64/libcurand.so
LIBS += /usr/local/cuda/lib64/libcufft.so

# nnxx
INCLUDEPATH += /usr/local/include
LIBS += /usr/local/lib/libnanomsg.so
LIBS += /usr/local/lib/libnnxx.a

SOURCES += \
    laser/Laser.cpp \
    laser/LivoxLaser.cpp \
    laser/LivoxMid100Laser.cpp \
    laser/LogFiles.cpp \
    laser/Point2D.cpp \
    laser/Point3D.cpp \
    src/CalibParam.pb.cc \
    src/StdCondition.cpp \
    main.cpp \
    mainwindow.cpp \
    modbus/LibmodbusWrapper.cpp \
    modbus/PLCMonitor.cpp \
    modbus/Runnable.cpp \
    TaskQueue/BaseTask.cpp \
    TaskQueue/ThreadTaskQueue.cpp \
    TaskQueue/TQFactory.cpp \
    src/measuretask.cpp \
    Process.cpp \
    src/pathcreator.cpp \
    laser/LivoxHubLaser.cpp \
    laser/Sick511FileLaser.cpp \
    laser/TcpLaser.cpp \
    laser/UdpLaser.cpp

HEADERS += \
    laser/Laser.h \
    laser/LivoxLaser.h \
    laser/LivoxMid100Laser.h \
    laser/LogFiles.h \
    laser/Point2D.h \
    laser/Point3D.h \
    src/CalibParam.pb.h \
    src/StdCondition.h \
    mainwindow.h \
    modbus/LibmodbusWrapper.h \
    modbus/PLCMonitor.h \
    modbus/Runnable.h \
    TaskQueue/threadpp/impl/pthread_lock.h \
    TaskQueue/threadpp/impl/pthread_lock.hpp \
    TaskQueue/threadpp/impl/pthread_thread.h \
    TaskQueue/threadpp/impl/pthread_thread.hpp \
    TaskQueue/threadpp/impl/std_lock.h \
    TaskQueue/threadpp/impl/std_lock.hpp \
    TaskQueue/threadpp/impl/std_thread.h \
    TaskQueue/threadpp/impl/std_thread.hpp \
    TaskQueue/threadpp/impl/win_lock.h \
    TaskQueue/threadpp/impl/win_lock.hpp \
    TaskQueue/threadpp/impl/win_thread.h \
    TaskQueue/threadpp/impl/win_thread.hpp \
    TaskQueue/threadpp/recursive_lock.h \
    TaskQueue/threadpp/threadpp.h \
    TaskQueue/threadpp/threadpp_assert.h \
    TaskQueue/BaseTask.h \
    TaskQueue/TaskPool.h \
    TaskQueue/ThreadTaskQueue.h \
    TaskQueue/TQFactory.h \
    TaskQueue/TQInterface.h \
    src/measuretask.h \
    Process.h \
    src/pathcreator.h \
    laser/LivoxHubLaser.h \
    qtmessagedef.h \
    laser/Sick511FileLaser.h \
    laser/TcpLaser.h \
    laser/UdpLaser.h

FORMS += \
        mainwindow.ui

win32:CONFIG(release, debug|release): LIBS += -L$$PWD/../../../../../usr/local/lib/release/ -lnanomsg
else:win32:CONFIG(debug, debug|release): LIBS += -L$$PWD/../../../../../usr/local/lib/debug/ -lnanomsg
else:unix: LIBS += -L$$PWD/../../../../../usr/local/lib/ -lnanomsg

INCLUDEPATH += $$PWD/''
DEPENDPATH += $$PWD/''
